/*Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-EPD037-1B
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Works with Arduino DUE,Arduino mega2560,Arduino UNO Board
****************************************************/
#include "ER-EPD037-1B.h"
#include "GUI_Paint.h"
#include "EPD_SDCard.h"
#include "ImageData.h"
#include <Wire.h>
#include <SPI.h>
#include <SD.h>
 
void setup()
{
    GUIPAINT paint;
    EPD3IN7 epd;
    EPD_SDCARD SD;

    if(epd.EPD_Init() != 0) {
        Serial.print("e-Paper init failed");
        return;
    }
    epd.EPD_Clear();
    // epd.EPD_Display();
    Serial.print("3.7inch e-Paper B demo\n");

#if 1
    /*show sd card pic*/
    //1.Initialize the SD card
    SD.SDCard_Init();

    //2.Create a new image cache named IMAGE_BW and fill it with white
    //Draw black image
    Serial.print("IMAGE_BW\n");
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    //3.Read BMP images into RAM
    SD.SDCard_ReadBMP("037-1b1.bmp", 0, 0);
    //4.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
    
     Serial.print("IMAGE_BW\n");
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    //Read BMP images into RAM
    SD.SDCard_ReadBMP("037-1b2.bmp", 0, 0);

    //Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);   
    

 #endif   
//#elif 1    

#if 0
    //show image for array
    //1.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    
    //2.show image for array, IMAGE_ROTATE_0 and IMAGE_COLOR_POSITIVE will not affect reading
    paint.Paint_DrawBitMap(IMAGE_DATA);
    
    //3.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);    
#endif



#if 1  
      //1.Create a new image cache named IMAGE_BW and fill it with white
    //Draw black picture
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_90, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    
    paint.Paint_DrawPoint(5, 10, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(5, 20, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
    paint.Paint_DrawLine(20, 20, 50, 50, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(50, 20, 20, 50, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawRectangle(60, 20, 90, 50, BLACK, DRAW_FILL_FULL, DOT_PIXEL_1X1);
    paint.Paint_DrawCircle(35, 90, 15, BLACK, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawString_EN(5, 120, "hello! EPD", &Font16, WHITE, BLACK);
    paint.Paint_DrawNum(5, 140, 123456789, &Font16, BLACK, WHITE);
    // epd.EPD_SetBlack();
    
    paint.Paint_DrawPoint(5, 30, RED, DOT_PIXEL_3X3, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(5, 40, RED, DOT_PIXEL_4X4, DOT_STYLE_DFT);
    paint.Paint_DrawLine(35, 75, 35, 105, RED, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(20, 90, 50, 90, RED, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawRectangle(20, 20, 50, 50, RED, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawCircle(75, 90, 15, RED, DRAW_FILL_FULL, DOT_PIXEL_1X1);
    paint.Paint_DrawString_EN(5, 160, "www.buydisplay.com", &Font16, RED, WHITE);
    paint.Paint_DrawString_EN(5, 200, "EastRising Technology", &Font16, WHITE, RED);
    // epd.EPD_SetRed();
    //3.Refresh the image in RAM to e-Paper
    epd.EPD_Display();

#endif

  Dev->Dev_Delay_ms(15000);
   epd.EPD_Clear();
     epd.EPD_TurnOnDisplay(); 
    epd.EPD_Sleep();


}

void loop()
{

}
